#include "strerr.h"
#include "readwrite.h"
#include "substdio.h"
#include "subscribe.h"
#include "exit.h"
#include "errtxt.h"

#define FATAL "ezmlm-list: fatal: "
void die_write()
{
  strerr_die2sys(111,FATAL,"unable to write: ");
}

static char outbuf[512];
static substdio ssout = SUBSTDIO_FDBUF(write,1,outbuf,sizeof(outbuf));

int subwrite(s,l)
char *s;
unsigned int l;
{
  return substdio_put(&ssout,s,l);
}

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;

  dir = argv[1];
  if (!dir) strerr_die1x(100,"ezmlm-list: usage: ezmlm-list dir");
  if (dir[0] != '/')
    strerr_die2x(100,FATAL,ERR_SLASH);

  (void) putsubs(dir,"",subwrite,FATAL);
  if (substdio_flush(&ssout) == -1) die_write(FATAL);
  _exit(0);
}
