#include "error.h"
#include "strerr.h"
#include "readwrite.h"
#include "str.h"
#include "stralloc.h"
#include "open.h"
#include "substdio.h"
#include "case.h"
#include "errtxt.h"
#include "subscribe.h"
#include "qmail.h"

static substdio ssin;
static char inbuf[512];
static stralloc line = {0};
static stralloc fnsub = {0};

static void die_nomem(fatal)
char *fatal;
{
  strerr_die2x(111,fatal,ERR_NOMEM);
}

static void die_write(fatal)
char *fatal;
{
  strerr_die3x(111,fatal,ERR_WRITE,"stdout");
}

unsigned int putsubs(dbname,userhost,subwrite,FATAL)
/* Outputs all userhostesses in 'dbname' to stdout. If userhost is not null */
/* that userhost is excluded.  Here 'dbname' is the base directory name.  */
/* subwrite must be a function returning 0 on success, 1 on error, and    */
/* taking arguments (char* string, unsigned int length). */

char *dbname;
char *userhost;
int (*subwrite)();
char *FATAL;

{
  int i;
  int fd;
  unsigned int no = 0;
  int match;
  unsigned int pos = 0;
  unsigned int hashpos;

  if (userhost && *userhost)
    pos = str_len(userhost)+2;	/* Tuserhost@host\0  used only if !flagself */
  if (!stralloc_copys(&fnsub,dbname)) die_nomem(FATAL);
  if (!stralloc_catb(&fnsub,"/subscribers/?",15)) die_nomem(FATAL);
  		/* NOTE: Also copies terminal '\0' */
  hashpos = fnsub.len - 2;

  for (i = 0;i < 53;++i) {
    fnsub.s[hashpos] = 64 + i;
    fd = open_read(fnsub.s);
    if (fd == -1) {
      if (errno != error_noent)
	strerr_die4sys(111,FATAL,ERR_READ,fnsub.s,": ");
    } else {
      substdio_fdbuf(&ssin,read,fd,inbuf,sizeof(inbuf));
      for (;;) {
        if (getln(&ssin,&line,&match,'\0') == -1)
          strerr_die4sys(111,FATAL,ERR_READ,fnsub.s,": ");
        if (!match)
          break;
        if ((line.len != pos) || case_diffb(userhost,pos-2,line.s+1)) {
          if (subwrite(line.s + 1,line.len - 2) == -1) die_write(FATAL);
          if (subwrite("\n",1) == -1) die_write(FATAL);
          no++;
        } 
      }
      close(fd);
    }
  }
  return no;
}

